package config

import (
	"gopkg.in/yaml.v2"
	"os"
)

type EnvConfig struct {
	DbType           string `yaml:"dbtype"`
	Server           string `yaml:"server"`
	Ip               string `yaml:"ip"`
	User             string `yaml:"user"`
	Password         string `yaml:"password"`
	DbName           string `yaml:"dbname"`
	Port             int    `yaml:"port"`
	SalveDbType      string `yaml:"salvedbtype"`
	SalveServer      string `yaml:"salveserver"`
	SalveIp          string `yaml:"salveip"`
	SalveUser        string `yaml:"salveuser"`
	SalvePassword    string `yaml:"salvepassword"`
	SalveDbName      string `yaml:"salvedbname"`
	SalvePort        int    `yaml:"salveport"`
	PlantNr          int    `yaml:"plantnr"`
	Filefolder       string `yaml:"filefolder"`
	Crontime         string `yaml:"crontime"`
	TemplatePath     string `yaml:"templatepath"`
	ReadTaskInterval int    `yaml:"readtaskinterval"`
	PrinterType      string `yaml:"printertype"`
	Printers         string `yaml:"printers"`
	Inbox            string `yaml:"inbox"`
	Outbox           string `yaml:"outbox"`
	Day              int    `yaml:"day"`
	Num              int    `yaml:"num"`
	Printobjtype     string `yaml:"printobjtype"`
	Begtime          string `yaml:"begtime"`
	Endtime          string `yaml:"endtime"`
	Shiptog          bool   `yaml:"shiptog"`
	Packtog          bool   `yaml:"packtog"`
}

//read yaml config
//注：path为yaml或yml文件的路径
func ReadYamlConfig(path string) (*EnvConfig, error) {
	conf := &EnvConfig{}
	f, err := os.Open(path)

	if err != nil {
		return nil, err
	} else {
		yaml.NewDecoder(f).Decode(conf)
	}
	defer f.Close()

	return conf, nil
}
