package Engine

import (
	"bufio"
	"fmt"
	"os"
	"testing"
)

var testIp = "10.111.245.110"
var testPort = 9100

// 测试端口打印机，打印单行信息
func TestSocketPrinter(t *testing.T) {
	sp := Printer{Ip: testIp, Port: testPort}
	err := sp.openSocket()
	defer sp.closeSocket()
	if err!= nil {
		t.Errorf("Failed to open the socket: %s:%d", "192.168.4.25",9100)
		t.Errorf("%v", err)
	}
	barcode := `^XA^FO100,100^BY1^FO200,60^A@N,35,35,E:SIMSUN.FNT^FD古麟剑^FS^FO200,
					100^BCN,100,N,N,N,N^FD$BARCODE$^FS^FO200,200^A@N,35,35,E:SIMSUN.FNT^FD$BARCODE$^FS^XZ`
	err = sp.printTaskBytesRow([]byte(barcode))
	if err!= nil {
		t.Errorf("Failed to print the task: %s", barcode)
		t.Errorf("%v", err)
	}
}

// 将打印文件输出到端口打印机打印
func TestSocketPrinterWithFile(t *testing.T) {
	var err error
	var file *os.File

	sp := Printer{Ip: testIp, Port: testPort}
	err = sp.openSocket()
	defer sp.closeSocket()
	if err!= nil {
		fmt.Println(err)
	}
	file, err = os.Open("D:\\GoVersion\\gopath\\src\\LAPP_SJA_ME\\Template\\Inbox\\00004788.XLSX")
	if err!= nil {
		fmt.Println(err)
	}
	defer file.Close()

	scanner := bufio.NewScanner(file)
	for scanner.Scan(){
		lineBytes := scanner.Bytes()
		fmt.Println(lineBytes)
		err = sp.printTaskBytesRow(lineBytes)
		if err!= nil {
			fmt.Println(err)
		}
	}
}
