package Engine

import (
	"LAPP_PRN_Service/db"
)

// 运行调度器，从管道获取打印任务并分发给对应的打印机
func StartScheduler(inChan chan db.PrintTask, prnDict map[string]*Printer) {
	// 从管道获取打印任务并分发
	go func() {
		var (
			prn *Printer
			ok  bool
			t   db.PrintTask
		)
		for {
			t = <-inChan
			if prn, ok = prnDict[t.PrinterId]; !ok {
				continue
			}
			prn.InTaskChan <- t
		}
	}()
}
